<template>
  <div>
    <!-- {{ editablePath }} -->
    <input :id="path.join('.')" v-model="fieldData" :disabled="config.read_only" :style="{ backgroundColor: isFieldEdited({ node, path }) ? '#c3dfff' : '' }">
  </div>
</template>

<script>
// import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // config: {
    //   type: Object,
    //   required: true
    // }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      isFieldEdited: 'Y3TI/isFieldEdited',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    fieldData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        return this.getEditedField({ node: this.node, path: this.path })
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
      }
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...[this.config.path] ]
    // }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
  }
}
</script>

<style lang="scss" scoped>
  input[disabled] {
    border: gray solid;
    background-color: gray;
    color: white;
  }
</style>
